
local M = {}

local timer = 0
local smoothRandom = 0
local waterTemp = 20
local thermostat = 0
local engineDamage = 0
local radiatorDamage = 0
local engineDamage1 = 0
local engineDamage2 = 0
local starter = 0
local lastStarter = 0
local stalled = 1
local governor = 400
local deltaRPM = 0
local lastRPM = 0
local lastGear = 0
local prevGear = 0
local nextGear = 0
local nextGearRatio = 0
local shiftTimer = 0
local rpmNeedle = 0
local rpmNeedleTarget = 0
local smoothThrottle = 0
local lastFuel = 80
local oilPressure = 0
local oilPressureS = 0
local vacuum = 0
local amperesS = 0
local damperStiffness = 0
local deltaThrottle = 0
local lastThrottle = 0
local smoothThrottle = 0
local smoothDeltaThrottle = 0
local transAccSmooth = 0
local deltaTorque = 0
local lastTorque = 0
local deltaRPM = 0
local lastRPM = 0
local deltaParking = 0
local lastParking = 0

local deltaSpringLenFL = 0
local deltaSpringLenFR = 0
local deltaSpringLenRL = 0
local deltaSpringLenRR = 0
local lastSpringLenFL = 0
local lastSpringLenFR = 0
local lastSpringLenRL = 0
local lastSpringLenRR = 0
local deltaWheelLoadFL = 0
local deltaWheelLoadFR = 0
local deltaWheelLoadRL = 0
local deltaWheelLoadRR = 0
local lastWheelLoadFL = 0
local lastWheelLoadFR = 0
local lastWheelLoadRL = 0
local lastWheelLoadRR = 0
local brakeFL = 0
local brakeFR = 0
local brakeRL = 0
local brakeRR = 0
local brakeTempFL = 20
local brakeTempFR = 20
local brakeTempRL = 20
local brakeTempRR = 20
local brakeFadeFL = 0
local brakeFadeFR = 0
local brakeFadeRL = 0
local brakeFadeRR = 0
local brakeSelfEnergFL = 0
local brakeSelfEnergFR = 0
local brakeSelfEnergRL = 0
local brakeSelfEnergRR = 0


local function onInit()

	--beam names
	for s,b in pairs(v.data.beams) do
		if     	b.name == "radiatorDamage1" then radiatorDamageBeam1 = b.cid
		elseif 	b.name == "radiatorDamage2" then radiatorDamageBeam2 = b.cid
		elseif 	b.name == "engineDamage1" 	then engineDamageBeam1 = b.cid
		elseif 	b.name == "engineDamage2" 	then engineDamageBeam2 = b.cid
		elseif 	b.name == "suspFL" 			then suspFL = b.cid
		elseif 	b.name == "suspFR" 			then suspFR = b.cid
		elseif 	b.name == "suspRL" 			then suspRL = b.cid
		elseif 	b.name == "suspRR" 			then suspRR = b.cid
		elseif	b.name == "hoodLatchBeam1" 	then hoodLatchBeam1 = b.cid
		elseif	b.name == "hoodLatchBeam2" 	then hoodLatchBeam2 = b.cid
		end
	end
	
	--node names
	for s,n in pairs(v.data.nodes) do
		if  n.name == "w12l" 	then wheelFLNode 	= n.cid elseif
			n.name == "w12r" 	then wheelFRNode 	= n.cid elseif
			n.name == "w22l" 	then wheelRLNode 	= n.cid elseif
			n.name == "w22r" 	then wheelRRNode 	= n.cid elseif
			n.name == "fr19l" 	then exhaustLNode 	= n.cid elseif
			n.name == "fr19r" 	then exhaustRNode 	= n.cid elseif
			n.name == "fu1l" 	then fuel1Node 		= n.cid elseif
			n.name == "fu1r" 	then fuel2Node 		= n.cid elseif
			n.name == "rad2" 	then radiator1Node 	= n.cid elseif
			n.name == "rad4" 	then radiator2Node 	= n.cid elseif
			n.name == "tra1" 	then transNode		= n.cid elseif
			n.name == "e1l"  	then engine1Node	= n.cid elseif
			n.name == "e2l"  	then engine2Node	= n.cid
		end
	end
	
	--wheel names
	--for w = 0,3  do
	--	if drivetrain.wheelInfo[w].name == "FL" then wFL = w end
	--	if drivetrain.wheelInfo[w].name == "FR" then wFR = w end
	--	if drivetrain.wheelInfo[w].name == "RL" then wRL = w end
	--	if drivetrain.wheelInfo[w].name == "RR" then wRR = w end
	--end
	
end

local function onReset()
	if waterTemp > 100 then waterTemp = 80 else waterTemp = 60 end
	engineDamage = 0
	radiatorDamage = 0
	lastGear = 0
	nextGear = 0
	governor = 400
	drivetrain.fuel = lastFuel
end

local function update10hz(dt)
	--disable autoclutch manual
	if  drivetrain.shifterMode == 1 then 
		drivetrain.toggleShifterMode()
	end
	
	--brakes
	--local wheelSpeedFL = math.abs(obj:getWheel(wFL).angularVelocity)
	--local wheelSpeedFR = math.abs(obj:getWheel(wFR).angularVelocity)
	--local wheelSpeedRL = math.abs(obj:getWheel(wRL).angularVelocity)
	--local wheelSpeedRR = math.abs(obj:getWheel(wRR).angularVelocity)
	--local brakeFL = drivetrain.wheels[wFL].brakeTorque
	--local brakeFR = drivetrain.wheels[wFR].brakeTorque
	--local brakeRL = drivetrain.wheels[wRL].brakeTorque
	--local brakeRR = drivetrain.wheels[wRR].brakeTorque
	
	--brake temperature and fade
	--brakeTempFL = math.min(900, math.max(20, (brakeTempFL + dt * brakeFL * input.brake * wheelSpeedFL * 0.001 - dt * electrics.values['airspeed'] * 0.12 - brakeTempFL / 80 * dt)))
	--brakeTempFR = math.min(900, math.max(20, (brakeTempFR + dt * brakeFR * input.brake * wheelSpeedFR * 0.001 - dt * electrics.values['airspeed'] * 0.12 - brakeTempFR / 80 * dt)))
	--brakeTempRL = math.min(900, math.max(20, (brakeTempRL + dt * brakeRL * input.brake * wheelSpeedRL * 0.001 - dt * electrics.values['airspeed'] * 0.10 - brakeTempRL / 80 * dt)))
	--brakeTempRR = math.min(900, math.max(20, (brakeTempRR + dt * brakeRR * input.brake * wheelSpeedRR * 0.001 - dt * electrics.values['airspeed'] * 0.10 - brakeTempRR / 80 * dt)))
	
	--brakeFadeFL = math.min(1, math.max(0, (math.abs(brakeTempFL - 100) * 0.0015)))
	--brakeFadeFR = math.min(1, math.max(0, (math.abs(brakeTempFR - 100) * 0.0015)))
	--brakeFadeRL = math.min(1, math.max(0, (math.abs(brakeTempRL - 100) * 0.0015)))
	--brakeFadeRR = math.min(1, math.max(0, (math.abs(brakeTempRR - 100) * 0.0015)))
	
	--drum brake self energizing 
	--brakeSelfEnergFL = math.min(0.4, math.max(0, (brakeSelfEnergFL + input.brake * wheelSpeedFL * dt * 0.02) - (1 - input.brake) * dt * 2))
	--brakeSelfEnergFR = math.min(0.4, math.max(0, (brakeSelfEnergFR + input.brake * wheelSpeedFR * dt * 0.02) - (1 - input.brake) * dt * 2))
	--brakeSelfEnergRL = math.min(0.4, math.max(0, (brakeSelfEnergRL + input.brake * wheelSpeedRL * dt * 0.02) - (1 - input.brake) * dt * 2))
	--brakeSelfEnergRR = math.min(0.4, math.max(0, (brakeSelfEnergRR + input.brake * wheelSpeedRR * dt * 0.02) - (1 - input.brake) * dt * 2))
	
	--brakeFL = math.min(1300, math.max(0, 1000 * (1 - brakeFadeFL) * (1 + brakeSelfEnergFL)))
	--brakeFR = math.min(1300, math.max(0, 1000 * (1 - brakeFadeFR) * (1 + brakeSelfEnergFR)))
	--brakeRL = math.min(1000, math.max(0,  600 * (1 - brakeFadeRL) * (1 + brakeSelfEnergRL)))
	--brakeRR = math.min(1000, math.max(0,  600 * (1 - brakeFadeRR) * (1 + brakeSelfEnergRR)))
	
	--drivetrain.wheels[wFL].brakeTorque = brakeFL
	--drivetrain.wheels[wFR].brakeTorque = brakeFR
	--drivetrain.wheels[wRL].brakeTorque = brakeRL
	--drivetrain.wheels[wRR].brakeTorque = brakeRR

	--hood latch beams
	--if hoodLatchBeam1 ~= nil then
	--	if electrics.values['turnsignal'] < -0.1 and input.parkingbrake > 0.9 then electrics.values['hoodL'] = 1 else electrics.values['hoodL'] = 0 end
	--	if electrics.values['turnsignal'] >  0.1 and input.parkingbrake > 0.9 then electrics.values['hoodR'] = 1 else electrics.values['hoodR'] = 0 end
	--	if electrics.values['hoodL'] == 0 and obj:getBeamLengthRestRatio(hoodLatchBeam1) < 1.2 then
	--		obj:setBeamSpringDamp(hoodLatchBeam1, 40000, 200, 40000, 500)	else
	--		obj:setBeamSpringDamp(hoodLatchBeam1,     0,   0,     0,   0)
	--	end
	--	if electrics.values['hoodR'] == 0 and obj:getBeamLengthRestRatio(hoodLatchBeam2) < 1.2 then
	--		obj:setBeamSpringDamp(hoodLatchBeam2, 40000, 200, 40000, 500)	else
	--		obj:setBeamSpringDamp(hoodLatchBeam2,     0,   0,     0,   0)
	--	end
	--end
end

local function updateGFX(dt)
	
	timer = timer + dt
	if timer > 0.1 then
		update10hz(dt)
		timer = 0
	end
	
	lastFuel = drivetrain.fuel
	
	smoothRandom = smoothRandom + (math.random(-100, 100) - smoothRandom) * dt * 10
	deltaRPM = drivetrain.rpm - lastRPM
	lastRPM = drivetrain.rpm
	
	--damper stiffness lever
	local damperControl = 0
	if input.keys['K'] == true then damperControl =  1 elseif input.keys['L'] == true then damperControl = -1 else damperControl = 0 end
	damperStiffness = math.min(1, math.max(-1, damperStiffness + damperControl * dt))
	electrics.values['dampers'] = damperStiffness
	
	--radiator damage from beam lengths
	--local radiatorDamage1 = math.abs(obj:getBeamLengthRestRatio(radiatorDamageBeam1) - 1)
	--local radiatorDamage2 = math.abs(obj:getBeamLengthRestRatio(radiatorDamageBeam2) - 1)
	--if radiatorDamage1 + radiatorDamage2 > 0.20 then radiatorDamage = 1 end
	--if waterTemp > 110 then radiatorDamage = 1 end
	
	--radiator cooling
	--local radiatorCooling = (10 + thermostat * (20 + electrics.values['airspeed'] * 2.0)) * 0.01 * (1 - radiatorDamage)
	
	--coolant temperature
	--waterTemp = waterTemp + dt * (drivetrain.throttle + 0.2) * drivetrain.rpm / 3000 - dt * radiatorCooling
	--if waterTemp < 20 then waterTemp = 20 end
	--electrics.values['coolantTemp'] = waterTemp
	--thermostat = math.min(1, math.max(0, (waterTemp - 85) * 0.1))
	
	--radiator steam
	--if radiatorDamage == 1 and waterTemp > 100 then
	--	obj:addParticleByNodesRelative(radiator1Node, radiator2Node, -5 +airspeed/5,  6, 0.2 +airspeed/30, 1 * math.random(30-airspeed,35)/30)
	--end
		
	--engine damage
	--if waterTemp > 115 then engineDamage = engineDamage + dt * 2 end
	--local engineDamage1 = math.abs(obj:getBeamLengthRestRatio(engineDamageBeam1) - 1)
	--local engineDamage2 = math.abs(obj:getBeamLengthRestRatio(engineDamageBeam2) - 1)
	--if engineDamage1 + engineDamage2 > 0.10 then engineDamage = engineDamage + dt * 20 end
	--local engineDamageThrottle = math.random(100 - engineDamage, 100) * 0.01
	
	--engine stall
	--if drivetrain.rpm < 100	and drivetrain.clutch < 0.1 then
	--	stalled = 1
	--	drivetrain.throttle = 0
	--end
	
	--engine starter
	--starter = 0
	--if stalled == 1
	--	and drivetrain.clutch > 0.9
	--	and drivetrain.rpm < 800 then
	--	starter = 1
	--end
	--if drivetrain.rpm > 800 then stalled = 0 end
	
	--engine idle
	local idleThrottle = 0
	if input.keys['T'] == true then governor = math.min(2000, math.max(0, governor + dt * 1000)) end
	if input.keys['G'] == true then governor = math.min(2000, math.max(0, governor - dt * 1000)) end
	electrics.values['governor'] = governor
	local idleRPM = governor
	if input.clutch > 0.9 then idleRPM = 400 end
	if stalled == 0
		and starter == 0
		and drivetrain.rpm < idleRPM + smoothRandom * 0.3
		then idleThrottle = 1 - 0.0001 * drivetrain.rpm
		elseif stalled == 1
		and starter == 1
		and drivetrain.rpm < 800
		then idleThrottle = 1.0 - 0.0010 * drivetrain.rpm
	end
	if drivetrain.shifterMode == 2 then stalled = 0 end
	
	--engine rev limiter
	local revLimiter = 1
	if drivetrain.rpm > 3700 + smoothRandom * 6 then revLimiter = 0 end
	
	--combine throttle effects
	--drivetrain.throttle = (drivetrain.throttle + idleThrottle) * engineDamageThrottle * revLimiter
	
	--no shifting without clutch & rev matching
	if drivetrain.shifterMode == 0 then
		if drivetrain.gear ~= lastGear then
			prevGear = lastGear
			nextGear = drivetrain.gear
			drivetrain.gear = 0
		end
		nextGearRatio = v.data.engine.gears[nextGear]
		if drivetrain.gear == 0 
			and nextGear >= 1
			and drivetrain.avgAV > 3
			and drivetrain.rpm > drivetrain.avgAV * nextGearRatio * 9.6 * 0.98 
			and drivetrain.rpm < drivetrain.avgAV * nextGearRatio * 9.6 * 1.02 
			and drivetrain.clutch > 0.9
			then drivetrain.gear = nextGear
		end
		if drivetrain.gear == 0 
			and drivetrain.avgAV < 3
			and drivetrain.clutch > 0.9
			then drivetrain.gear = nextGear
		end
	end
	--arcade auto hack
	if drivetrain.shifterMode == 2 then
		shiftTimer = shiftTimer + dt
		if drivetrain.gear ~= lastGear and shiftTimer < 1 then
			prevGear = lastGear
			nextGear = drivetrain.gear
			drivetrain.gear = prevGear
		end
		if shiftTimer < 0.9 and nextGear > 1 and drivetrain.gear ~= nextGear then drivetrain.throttle = 0 end
		if shiftTimer > 0.9 then 
			drivetrain.gear = nextGear
			shiftTimer = 0
		end
	end
	
	smoothThrottle = smoothThrottle + (drivetrain.throttle - smoothThrottle) * dt * 8
	drivetrain.throttle = smoothThrottle
	deltaThrottle = drivetrain.throttle - lastThrottle
	lastThrottle = drivetrain.throttle
	smoothDeltaThrottle = smoothDeltaThrottle + (deltaThrottle - smoothDeltaThrottle) * dt * 20
	deltaTorque = drivetrain.torque - lastTorque
	lastTorque = drivetrain.torque
	
	
	
	rpmNeedleTarget = rpmNeedle - drivetrain.rpm + math.min(100, math.max(-100, deltaRPM * math.random(0, 10) / dt / 80))
	rpmNeedle = rpmNeedle - math.min(1000, math.max(-1000, rpmNeedleTarget * math.random(0, math.abs(deltaRPM/10)) / 5))
	electrics.values['rpmNeedle'] = rpmNeedle
	
	oilPressure = (math.abs(rpmNeedle) / 5000)^0.3 * (drivetrain.throttle * 0.3 + 0.7) * (1.01 - engineDamage/100)^9
	oilPressureS = oilPressureS + (oilPressure - oilPressureS) * dt * 1
	electrics.values['oilPressure'] = oilPressureS
	
	
	local amperes =  drivetrain.rpm / 5000 - starter * 0.8
	amperesS = amperesS + (amperes - amperesS) * dt * 22
	electrics.values['amperes'] = amperesS
	
	electrics.values['volts'] = 0
	
	--fake vacuum gauge
	vacuum = math.min(1, math.max(0, vacuum + (0.8 - ((drivetrain.throttle+0.01)^1.5)*0.5 - stalled - deltaRPM / dt / 12000) * dt * 5)) / 1.1
	electrics.values['vacuum'] = vacuum
	
	--clock
	local dateTime = os.date("*t", os.time())
	local psec = dateTime.sec / 60
	local pmin = (dateTime.min + psec) / 60
	local ph = (dateTime.hour % 12) / 12 + (pmin) / 12
	electrics.values['clockS'] = psec
	electrics.values['clockM'] = pmin
	electrics.values['clockH'] = ph
	
	--dash warning light
	if drivetrain.gear ~= nextGear then electrics.values['dlight'] = 0 else electrics.values['dlight'] = 1 end
	
	--exhaust particles
	--obj:addParticleByNodesRelative(exhaustLNode, transNode, 1, 60, 0, 2)
	--obj:addParticleByNodesRelative(exhaustLNode, transNode, -(drivetrain.throttle * drivetrain.rpm^0.5 / 2) -0.5 +airspeed, 24, 0.05 +airspeed/10, ((drivetrain.throttle * drivetrain.rpm / 500) + 0.05) * math.random(0, 25-airspeed)/25)
	--obj:addParticleByNodesRelative(exhaustRNode, transNode, -(drivetrain.throttle * drivetrain.rpm^0.5 / 2) -0.5 +airspeed, 71, 0.05 +airspeed/10, ((drivetrain.throttle * drivetrain.rpm / 500) + 0.05) * math.random(0, 25-airspeed)/25)
	
	--engine sounds
	electrics.values['throttleIdle'] = drivetrain.throttle * 0.4 + 0.5 - starter
	electrics.values['throttle1'] = drivetrain.throttle^0.2 * 0.8
	electrics.values['throttle2'] = drivetrain.throttle * 0.9 + smoothDeltaThrottle / dt / 8
	electrics.values['throttleOff'] = (1 - drivetrain.throttle - smoothDeltaThrottle / dt / 10) * 0.7
	
	-- gearwhine
	electrics.values['gearwhineV'] = 0.20 + smoothThrottle * 0.10
	
	-- exhaust sound
	electrics.values['exhaustV'] = -smoothDeltaThrottle / dt * drivetrain.rpm / 100 * math.random(-10,1)
	
	--starter
	electrics.values['starterV'] = starter
	if lastStarter < starter then sounds.playSoundOnceAtNode("Auriga258Start1", engine1Node, 0.8) end
	if lastStarter > starter and drivetrain.rpm > 400 then sounds.playSoundOnceAtNode("Auriga258Start3", engine1Node, 0.9) end
	lastStarter = starter
	
	--shifting
	if lastGear ~= drivetrain.gear and drivetrain.gear == 0 then sounds.playSoundOnceAtNode("Auriga258Shift1", transNode, 0.7) end
	if lastGear ~= drivetrain.gear and drivetrain.gear ~= 0 then sounds.playSoundOnceAtNode("Auriga258Shift2", transNode, 0.8) end
	if lastGear ~= drivetrain.gear and input.clutch < 0.8 and drivetrain.shifterMode == 0 then sounds.playSoundOnceAtNode("Auriga258ShiftGrind", transNode, 0.6) end
	lastGear = drivetrain.gear
		
	-- transmission sound
	local transSpeed = math.abs(drivetrain.avgAV)
	local transAcc = math.min(1, math.max(-1, drivetrain.torqueTransmission / 800))
	transAccSmooth = transAccSmooth + (transAcc - transAccSmooth) * dt * 10
	electrics.values['transAccP'] = transSpeed * 0.008
	electrics.values['transAccV'] = transAccSmooth/4 + transAcc * 0.1
	electrics.values['transDecP'] = transSpeed * 0.008
	electrics.values['transDecV'] = -transAccSmooth/5 - transAcc * 0.1
	
	-- brake whine
	electrics.values['brakeP'] = math.abs(drivetrain.avgAV)^0.3 * 0.09 + 0.6
	electrics.values['brakeV'] = input.brake * math.abs(drivetrain.avgAV)^0.5 * 0.05 - 0.05
	
	-- parking brake
	deltaParking = input.parkingbrake - lastParking
	lastParking = input.parkingbrake
	electrics.values['parkingV'] = deltaParking / dt * 20
	
	-- wheel bump sound
	--local wheelLoadFL = drivetrain.wheelInfo[wFL].downForceRaw
	--local wheelLoadFR = drivetrain.wheelInfo[wFR].downForceRaw
	--local wheelLoadRL = drivetrain.wheelInfo[wRL].downForceRaw
	--local wheelLoadRR = drivetrain.wheelInfo[wRR].downForceRaw
	--deltaWheelLoadFL = (wheelLoadFL - lastWheelLoadFL) / dt
	--deltaWheelLoadFR = (wheelLoadFR - lastWheelLoadFR) / dt
	--deltaWheelLoadRL = (wheelLoadRL - lastWheelLoadRL) / dt
	--deltaWheelLoadRR = (wheelLoadRR - lastWheelLoadRR) / dt
	--lastWheelLoadFL = wheelLoadFL
	--lastWheelLoadFR = wheelLoadFR
	--lastWheelLoadRL = wheelLoadRL
	--lastWheelLoadRR = wheelLoadRR
	--electrics.values['bumpPFL'] =  0.1 + deltaWheelLoadFL / 20000 * dt
	--electrics.values['bumpPFR'] =  0.1 + deltaWheelLoadFR / 20000 * dt
	--electrics.values['bumpPRL'] =  0.1 + deltaWheelLoadRL / 20000 * dt
	--electrics.values['bumpPRR'] =  0.1 + deltaWheelLoadRR / 20000 * dt
	--electrics.values['bumpVFL'] = -0.2 + deltaWheelLoadFL / 10000 * dt
	--electrics.values['bumpVFR'] = -0.2 + deltaWheelLoadFR / 10000 * dt
	--electrics.values['bumpVRL'] = -0.2 + deltaWheelLoadRL / 10000 * dt
	--electrics.values['bumpVRR'] = -0.2 + deltaWheelLoadRR / 10000 * dt
	
	--suspension creak
	local springLenFL = obj:getBeamLengthRestRatio(suspFL)
	local springLenFR = obj:getBeamLengthRestRatio(suspFR)
	local springLenRL = obj:getBeamLengthRestRatio(suspRL)
	local springLenRR = obj:getBeamLengthRestRatio(suspRR)
	deltaSpringLenFL = (springLenFL - lastSpringLenFL) / dt
	deltaSpringLenFR = (springLenFR - lastSpringLenFR) / dt
	deltaSpringLenRL = (springLenRL - lastSpringLenRL) / dt
	deltaSpringLenRR = (springLenRR - lastSpringLenRR) / dt
	lastSpringLenFL = springLenFL
	lastSpringLenFR = springLenFR
	lastSpringLenRL = springLenRL
	lastSpringLenRR = springLenRR
	electrics.values['suspP'] = 0.30 + math.abs(deltaSpringLenFL + deltaSpringLenFR + deltaSpringLenRL + deltaSpringLenRR) / 100
	electrics.values['suspV'] = -0.1 + (math.abs(deltaSpringLenFL + deltaSpringLenFR + deltaSpringLenRL + deltaSpringLenRR))^0.5 / 8
end

-- public interface
M.onInit = onInit
M.onReset = onReset
M.updateGFX = updateGFX

return M